@echo off
set self=%~d0%~p0

echo.
echo Welcome to the BDA setup for Windows Server 2008 R2!
echo ----------------------------------------------------
echo.
echo This batch file does only work with administrative privileges!
echo.
echo Batch file location is:
echo %self%
echo.
echo Please cancel if it is incorrect or if you don't have access permissions.
echo.
echo.
echo Press any key to continue.
pause >nul
echo.
echo.
echo Please enter your system locale and press enter.
echo It must be the same as on the OS you grabbed the files before.
echo.
echo Examples: en-US, de-DE
echo.
set /P loc=

set src32=%self%files\System32
set src64=%self%files\SysWOW64

for /F %%G in ('dir "%systemroot%\System32\DriverStore\FileRepository\bda.inf_*" /s /b') do (
if exist "%%G\bdasup.sys" set drv=%%G\bdasup.sys
)

echo.
echo BDA driver found is:
echo %drv%
echo.
echo.
echo Press any key to continue.
pause >nul

echo.
echo.
echo Installing BDA drivers...
echo.

copy "%drv%" "%systemroot%\inf\bdasup.sys"
rundll32.exe advpack.dll,LaunchINFSection "%systemroot%\inf\bda.inf",,1
rundll32.exe advpack.dll,LaunchINFSection "%self%drv\bda.inf",,1

echo.
echo Copying grabbed files...
echo.

move "%src32%\bdaplgin.ax" %systemroot%\System32
move "%src32%\kstvtune.ax" %systemroot%\System32
move "%src32%\ksxbar.ax" %systemroot%\System32
move "%src32%\Mpeg2Data.ax" %systemroot%\System32
move "%src32%\mpg2splt.ax" %systemroot%\System32
move "%src32%\MSDvbNP.ax" %systemroot%\System32
move "%src32%\MSNP.ax" %systemroot%\System32
move "%src32%\MSVidCtl.dll" %systemroot%\System32
move "%src32%\%loc%\MSVidCtl.dll.mui" %systemroot%\System32\%loc%
move "%src32%\%loc%\kstvtune.ax.mui" %systemroot%\System32\%loc%
move "%src32%\%loc%\kswdmcap.ax.mui" %systemroot%\System32\%loc%
move "%src32%\%loc%\ksxbar.ax.mui" %systemroot%\System32\%loc%
move "%src32%\psisdecd.dll" %systemroot%\System32
move "%src32%\psisrndr.ax" %systemroot%\System32
move "%src32%\VBICodec.ax" %systemroot%\System32
move "%src32%\vbisurf.ax" %systemroot%\System32
move "%src32%\WSTPager.ax" %systemroot%\System32

move "%src64%\bdaplgin.ax" %systemroot%\SysWOW64
move "%src64%\kstvtune.ax" %systemroot%\SysWOW64
move "%src64%\ksxbar.ax" %systemroot%\SysWOW64
move "%src64%\Mpeg2Data.ax" %systemroot%\SysWOW64
move "%src64%\mpg2splt.ax" %systemroot%\SysWOW64
move "%src64%\MSDvbNP.ax" %systemroot%\SysWOW64
move "%src64%\MSNP.ax" %systemroot%\SysWOW64
move "%src64%\MSVidCtl.dll" %systemroot%\SysWOW64
move "%src64%\%loc%\MSVidCtl.dll.mui" %systemroot%\SysWOW64\%loc%
move "%src64%\%loc%\kstvtune.ax.mui" %systemroot%\SysWOW64\%loc%
move "%src64%\%loc%\kswdmcap.ax.mui" %systemroot%\SysWOW64\%loc%
move "%src64%\%loc%\ksxbar.ax.mui" %systemroot%\SysWOW64\%loc%
move "%src64%\psisdecd.dll" %systemroot%\SysWOW64
move "%src64%\psisrndr.ax" %systemroot%\SysWOW64
move "%src64%\VBICodec.ax" %systemroot%\SysWOW64
move "%src64%\vbisurf.ax" %systemroot%\SysWOW64
move "%src64%\WSTPager.ax" %systemroot%\SysWOW64

echo.
echo Registering libraries...
echo.

%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\bdaplgin.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\kstvtune.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\ksxbar.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\Mpeg2Data.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\mpg2splt.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\MSDvbNP.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\MSNP.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\MSVidCtl.dll 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\psisdecd.dll 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\psisrndr.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\VBICodec.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\vbisurf.ax 
%systemroot%\SysWOW64\regsvr32 /s %systemroot%\SysWOW64\WSTPager.ax 
%systemroot%\System32\regsvr32 /s %systemroot%\System32\bdaplgin.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\kstvtune.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\ksxbar.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\Mpeg2Data.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\mpg2splt.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\MSDvbNP.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\MSNP.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\MSVidCtl.dll
%systemroot%\System32\regsvr32 /s %systemroot%\System32\psisdecd.dll
%systemroot%\System32\regsvr32 /s %systemroot%\System32\psisrndr.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\VBICodec.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\vbisurf.ax
%systemroot%\System32\regsvr32 /s %systemroot%\System32\WSTPager.ax

echo.
echo Updating BDA drivers...
echo.

rundll32.exe advpack.dll,LaunchINFSection "%systemroot%\inf\bda.inf",,1

echo.
echo.
echo Finished! You should not see any errors above.
echo.
echo Files that may have not been copied remain in the files folder under:
echo %self%
echo.
echo Press any key to reboot your system or close this window and reboot later.
pause >nul

echo.
echo Rebooting...
shutdown /r